'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var config = require('@rontrol/config');
var persister = require('@rontrol/persister');
var core = require('@react2rx/core');
var router = require('@react2rx/router');
var history = require('history');
var lodash = require('@rontrol/lodash');
var react = require('react');
var client = require('react-dom/client');
var notify = require('@rontrol/notify');
var jsxRuntime = require('react/jsx-runtime');

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n["default"] = e;
  return Object.freeze(n);
}

function PersisterConnect(_ref) {
  var {
    persister
  } = _ref;
  var store$ = /*#__PURE__*/core.useStore();
  react.useEffect(() => {
    var cleanup = /*#__PURE__*/persister.connect(store$);
    return () => {
      cleanup();
    };
  }, []);
  return null;
}

var HistoryProvider = _ref2 => {
  var {
    children,
    basename = ""
  } = _ref2;
  var confirm = /*#__PURE__*/notify.useConfirm();
  var history$1 = /*#__PURE__*/react.useMemo(() => history.createBrowserHistory({}), []);
  return /*#__PURE__*/jsxRuntime.jsx(router.PromptUserConfirmation, {
    getUserConfirmation: confirm,
    children: /*#__PURE__*/jsxRuntime.jsx(router.ReactorxRouter, {
      basename: basename,
      history: history$1,
      children: children
    })
  });
};
var HashHistoryProvider = _ref3 => {
  var {
    children
  } = _ref3;
  var confirm = /*#__PURE__*/notify.useConfirm();
  var history$1 = /*#__PURE__*/react.useMemo(() => history.createHashHistory({}), []);
  return /*#__PURE__*/jsxRuntime.jsx(router.PromptUserConfirmation, {
    getUserConfirmation: confirm,
    children: /*#__PURE__*/jsxRuntime.jsx(router.ReactorxRouter, {
      history: history$1,
      children: children
    })
  });
};
var createBootstrap = config$1 => e => {
  console.log(config$1);
  var persister$1 = /*#__PURE__*/persister.createPersister({
    name: config$1.appName || "app"
  });
  return function ($root) {
    var strictMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    var r = /*#__PURE__*/client.createRoot($root);
    void persister$1.hydrate(function () {
      var storeValues = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var store$ = /*#__PURE__*/core.Store.create(storeValues);

      if (process.env.NODE_ENV !== "production") {
        // @ts-ignore
        void Promise.resolve().then(function () { return /*#__PURE__*/_interopNamespace(require('redux-logger')); }).then(_ref4 => {
          var {
            createLogger
          } = _ref4;
          store$.applyMiddleware( /*#__PURE__*/createLogger({
            duration: true,
            collapsed: true,
            errorTransformer: e => {
              throw e;
            },
            colors: {
              title: actor => {
                switch (actor.stage) {
                  case core.AsyncStage.STARTED:
                    return "blue";

                  case core.AsyncStage.DONE:
                    return "green";

                  case core.AsyncStage.FAILED:
                    return "red";

                  case core.AsyncStage.CANCEL:
                    return "orange";
                }

                return "black";
              }
            }
          }));
        });
      }

      var app = /*#__PURE__*/jsxRuntime.jsx(core.StoreProvider, {
        value: store$,
        children: /*#__PURE__*/jsxRuntime.jsxs(config.ConfigProvider, {
          value: {
            config: config$1
          },
          children: [/*#__PURE__*/jsxRuntime.jsx(PersisterConnect, {
            persister: persister$1
          }), /*#__PURE__*/jsxRuntime.jsx(HistoryProvider, {
            basename: config$1.basename,
            children: lodash.isFunction(e) ? e() : e
          })]
        })
      });

      if (strictMode) {
        r.render( /*#__PURE__*/jsxRuntime.jsx(react.StrictMode, {
          children: app
        }));
      } else {
        r.render(app);
      }
    });
  };
};

exports.HashHistoryProvider = HashHistoryProvider;
exports.HistoryProvider = HistoryProvider;
exports.createBootstrap = createBootstrap;
